''' $Id$
'''
'''  Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
'''  
'''  You may redistribute only under the terms of the Artistic Licence,
'''  as specified in the README file that comes with the distribution.
'''  You may reuse parts of this distribution only within the terms of
'''  that same Artistic Licence; a copy of which may be found at the root
'''  of the source tree for dist 4.0.
'''
''' $Log: packinit.man,v $
''' Revision 3.0.1.4  1995/07/25  13:31:38  ram
''' patch56: fixed a typo
'''
''' Revision 3.0.1.3  1995/05/12  11:57:38  ram
''' patch54: updated my e-mail address
'''
''' Revision 3.0.1.2  1994/10/29  15:45:17  ram
''' patch36: added new variables cext, shext, changelog and changercs
'''
''' Revision 3.0.1.1  1994/01/24  13:54:31  ram
''' patch16: now documents variables set in .package by packinit
'''
''' Revision 3.0  1993/08/18  12:04:06  ram
''' Baseline for dist 3.0 netwide release.
'''
''' 
.TH PACKINIT 1 ram
.SH NAME
packinit \- initialize or update your .package file
.SH SYNOPSIS
.B packinit
.SH DESCRIPTION
.B Packinit
will create (or update) a \fI.package\fR file, so that all the
.B dist
tools can be smart and know some basic things about your package,
such as its revision number, or the e-mail address of its maintainer.
.PP
.I Packinit
should be run from the top level directory of your package, before
using any other \fIdist\fR tool. Later on, you may rerun it to
update some of its values.
.I Packinit
will create a single file and leave the remaining of
your directory undisturbed.
.SH VARIABLES
.I Packinit
defines the following variables in your \fI.package\fR file:
.TP 15
.PD 0
baserev
The baseline revision number.
.TP
cext
The list (space separated) of file extensions identifying potential holders of
C symbols. This is added to the default .[chyl] extension lookup.
Shell-style patterns may be used.
.TP
changelog
The name of the \fIChangeLog\fR file managed by \fIpatlog\fR.
.TP
changercs
Boolean stating whether RCS logs are to be made part of \fIChangeLog\fR.
.TP
copyright
Name of the file used for Copyright expansion.
.TP
ftpdir
Directory where patches are located on the FTP site.
.TP
ftpsite
Name of the FTP site where patches may be retrieved from.
.TP
list_addr
Address of the package mailing list where users may post messages to.
.TP
list_manager
Type of list manager attached to the list administrative request address.
.TP
list_name
Name of the package users mailing list.
.TP
list_request
Address where subscribe and unsubscribe requests for the package mailing
list should be sent to.
.TP
list_sub
Format of the subscribe requests.
.TP
list_unsub
Format of the unsubscribe requests.
.TP
list_users
A boolean string set to 'true' when there is a mailing list set up for
discussion about the package.
.TP
mailagent
A boolean string set to 'true' when people are allowed to retrieve
patches via mailagent \fI@SH mailpatch\fR commands.
.TP
maintloc
E-mail address of the package maintainer, preferably in Internet format.
.TP
maintname
Full name of the package maintainer.
.TP
mydiff
Name of the \fIdiff\fR program to be used when computing a patch.
.TP
newsgroups
Newsgroup list where new patches should be posted to, empty for no
postings.
.TP
orgname
Full name of the organization where the package maitainer resides, or
path to a file containing that name.
.TP
package
Name of the package.
.TP
packver
Version of the \fIpackinit\fR program that built the \fI.package\fR file.
.TP
patchbranch
Name of the RCS branch used to store subsequent updates of a file after
a baseline has been released.
.TP
recipients
People who should be sent newly issued patches.
.TP
shext
The list (space separated) of file extensions identifying potential holders of
shell symbols. This is added to the default .SH extension lookup.
Shell-style patterns may be used. Note that only .SH extensions are looked
up by Configure for automatic shell extraction with variable substitutions,
no matter what this variable is set to.
.PD
.SH FILE
.TP 15
\&.package
File holding all the package-related values
.SH AUTHORS
Larry Wall <lwall@netlabs.com> (version 2.0)
.br
Raphael Manfredi <Raphael.Manfredi@pobox.com>
.SH "SEE ALSO"
dist(1).
